//*************************************************************************************
// 	: SQ7515_startup_LVD_SWRST.c
// 汾		: V1.0
// 		: 
// ע		: 
//**************************************************************************************

/*
 * --------------------------------------------------------------------------
 *   HEADER INCLUDE DEFINITIONS
 * --------------------------------------------------------------------------
 */
#include <stdlib.h>
#include "SQ7515_SFR.h"


/*
 * --------------------------------------------------------------------------
 *   MACRO DEFINITIONS
 * --------------------------------------------------------------------------
 */
 
extern unsigned int _BaseSP;				/*ѵָʼַһ㶨SRAMһַ*/
extern unsigned int _RAM_Top;				/*SRAMĵһַ*/
extern unsigned int _RAM_End;				/*SRAMһַ*/

extern unsigned char _TDataAddr[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned char _TDataOrg[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned int _TDataSize;				/* for tiny_data initialize, defined in link command file  */
extern unsigned char _NDataAddr[];			/* for near_data initialize, defined in link command file  */
extern unsigned char _NDataOrg[];			/* for near_data initialize, defined in link command file  */
extern unsigned int _NDataSize;				/* for near_data initialize, defined in link command file  */

/*
 * --------------------------------------------------------------------------
 *   FUNCTION DECLARATIONS
 * --------------------------------------------------------------------------
 */

/*#**************************************************************************#*/

/*
 ******************************************************************************
 * NAME				:STARTUP
 *-----------------------------------------------------------------------------
 * DESCRIPTION		:Startup routine
 * PARAMETER		:-
 *
 * RETURN VALUE		:-
 *
 ******************************************************************************
 */
void STARTUP(void)
{
    unsigned int VDD_Lower_DTVT_CNT;    // VDDڼѹ֮(Cnt Vdd Lower Than Detect Voltage)
    unsigned int i,j;
	
    CLKCR1_HIRCEN = 1;                  //  HIRC
    while(CLKCR1_HIRCRDY == 0);         // ȴ HIRC 
    CLKCR0 = 0x10;                      // ϵͳƵʳ2   (16K/2=8KHz) 

    VDD_Lower_DTVT_CNT = 0;             // VDDڼѹֵ֮Ϊ0
//=============================================================================
// memory mapping
//=============================================================================
    DMCFG  	 = 0x50;                    // Code :0x8000~0xFFFF Map to Data: 0x8000~0xFFFF,Cһʹ0x50
    //DMCFG  = 0x40;                      // Code :0x0000~0x7FFF Map to Data: 0x8000~0xFFFF
    //DMCFG  = 0x00;                      // No Map

//=============================================================================
// Setting detection voltage (3.15 V   126 mV)
//=============================================================================
    P0PU = 0xFF;                        // .
    P1PU = 0xFF;
    P2PU = 0xFF;
    P3PU = 0xFF;
    P4PU = 0xFF;
    P5PU = 0xFF;

    P2OE_P0 = 1;                        // 趨P2.0 ܽΪ
    P2PU_P0 = 0;                        // 趨P2.0 .

    P2DO_P0=0;                          // LED1(P2.0)
    for(i=0;i<1500;i++){                // ʱһʱ
        for(j=1500;j>0;j--);
    }

    P2DO_P0=1;                          // ʹLED1(P2.0)
    for(i=0;i<1500;i++){                // ʱһʱ
        for(j=1500;j>0;j--);
    }

    LVDCR_LVDCFG = 4;                   // üѹΪ3.15 V   126 mV		
    LVDCR_LVDEN  = 1;                   // LVD

	while(1){
        WDCDR = 0x4E;                   // 룬Źʱ (ι)
        if(LVDCR_LVDF == 1 && LVDCR_LVDST == 1){
            VDD_Lower_DTVT_CNT ++;      // ⵽LVD(VDD <  趨֮ѹ)"VDDڼѹ֮"+1
            if(VDD_Lower_DTVT_CNT >= 50){	
                break;                  // ⵽LVD(VDD <  趨֮ѹ)(50+1)Σ뿪ˏhȦ
            }
        }
        else{
            VDD_Lower_DTVT_CNT = 0;     // ⵽LVD(VDD >= 趨֮ѹ) "VDDڼѹ֮"0
        }
		
        if(LVDCR_LVDF == 1){
            LVDCR_LVDF = 1;             // ⵽LVDLVDΪ1 
        }		
    }

    LVDCR_LVDIEN 	= 1;                // LVD 
    IER_LVD 		= 1;                // LVD ж
    __ASM("EI");                        // жĴ



//=============================================================================
// initial Registers
//=============================================================================
	__WA = 0x00;
	__BC = 0x00;
	__DE = 0x00;
	__HL = 0x00;
	__IX = 0x00;
	__IY = 0x00;

//=============================================================================
// initial Setting
//=============================================================================	
	__asm("CLR (0x08).5");

//=============================================================================
// initialize stack pointer
//=============================================================================
	__asm(" LD SP,__BaseSP");	//initialize stack pointer

//=============================================================================
// clear status word
//=============================================================================
	__asm(" LD PSW,0x00");

//=============================================================================
// clear RAM
//=============================================================================
	__asm(" LD HL,__RAM_Top");
	__asm(" LD BC,__RAM_End - __RAM_Top");	
	__asm(" LD A,0x00");
	__asm("CLR_RAM:");
	__asm(" LD (HL),A");
	__asm(" INC HL");
	__asm(" DEC BC");
	__asm(" JRS F,CLR_RAM");		/* Clear the RAM */

//=============================================================================
// initialize of tiny_data section
//=============================================================================
	__asm("	LD	IX,__TDataOrg");
	__asm("	LD	IY,__TDataAddr");
	__asm("	LD	A,__TDataSize");
	__asm("	DEC	A");
	__asm("	J	T,non_t_data");
	__asm("move_t_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	A");
	__asm("	J	F,move_t_data");
	__asm("non_t_data:");

//=============================================================================
// initialize of near_data section
//=============================================================================
	__asm("	LD	IX,__NDataOrg");
	__asm("	LD	IY,__NDataAddr");
	__asm("	LD	WA,__NDataSize");
	__asm("	DEC	WA");
	__asm("	J	T,non_n_data");
	__asm("move_n_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	WA");
	__asm("	J	F,move_n_data");
	__asm("non_n_data:");


//=============================================================================
// jump to main
//=============================================================================
	main();
	for (;;) {
		;
	}
}

